diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java b/game/client/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
index f12b0a0da..7694bc9ce 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
@@ -4,39 +4,32 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.OptionVolume;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
 import java.util.HashMap;
 
-public class SoundCategoryHelper
-{
+public class SoundCategoryHelper {
     private static final Logger LOGGER = LogUtils.getLogger();
     private static final HashMap<SoundCategory, Field> VOLUME_FIELDS = new HashMap<>();
 
-    static
-    {
-        try
-        {
-            VOLUME_FIELDS.put(SoundCategory.MUSIC, GameSettings.class.getDeclaredField("musicVolume"));
-            VOLUME_FIELDS.put(SoundCategory.WORLD_SOUNDS, GameSettings.class.getDeclaredField("worldSoundsVolume"));
-            VOLUME_FIELDS.put(SoundCategory.WEATHER_SOUNDS, GameSettings.class.getDeclaredField("weatherSoundsVolume"));
-            VOLUME_FIELDS.put(SoundCategory.ENTITY_SOUNDS, GameSettings.class.getDeclaredField("entitySoundsVolume"));
-            VOLUME_FIELDS.put(SoundCategory.CAVE_SOUNDS, GameSettings.class.getDeclaredField("caveSoundsVolume"));
-            VOLUME_FIELDS.put(SoundCategory.GUI_SOUNDS, GameSettings.class.getDeclaredField("guiSoundsVolume"));
-        }
-        catch (NoSuchFieldException e)
-        {
+    static {
+        try {
+            VOLUME_FIELDS.put(SoundCategory.MUSIC, GameSettings.class.getDeclaredField("MUSIC_VOLUME"));
+            VOLUME_FIELDS.put(SoundCategory.WORLD_SOUNDS, GameSettings.class.getDeclaredField("WORLD_SOUNDS_VOLUME"));
+            VOLUME_FIELDS.put(SoundCategory.WEATHER_SOUNDS, GameSettings.class.getDeclaredField("WEATHER_SOUNDS_VOLUME"));
+            VOLUME_FIELDS.put(SoundCategory.ENTITY_SOUNDS, GameSettings.class.getDeclaredField("ENTITY_SOUNDS_VOLUME"));
+            VOLUME_FIELDS.put(SoundCategory.CAVE_SOUNDS, GameSettings.class.getDeclaredField("CAVE_SOUNDS_VOLUME"));
+            VOLUME_FIELDS.put(SoundCategory.GUI_SOUNDS, GameSettings.class.getDeclaredField("GUI_SOUNDS_VOLUME"));
+        } catch (NoSuchFieldException e) {
             throw new RuntimeException(e);
         }
     }
 
-    public static boolean isAnyEnabled(GameSettings gameSettings)
-    {
-        for (SoundCategory category : SoundCategory.values())
-        {
-            if (getEffectiveVolume(category, gameSettings) > 0F)
-            {
+    public static boolean isAnyEnabled() {
+        for (SoundCategory category : SoundCategory.values()) {
+            if (getEffectiveVolume(category) > 0F) {
                 return true;
             }
         }
@@ -44,51 +37,39 @@ public class SoundCategoryHelper
         return false;
     }
 
-    public static float getVolume(SoundCategory category, GameSettings gameSettings)
-    {
+    public static float getVolume(SoundCategory category) {
         Field field = VOLUME_FIELDS.get(category);
         if (field == null) return 0.0f;
 
-        try
-        {
-            return ((OptionVolume) field.get(gameSettings)).value;
-        }
-        catch (Exception e)
-        {
+        try {
+            return ((OptionVolume) field.get(null)).value;
+        } catch (Exception e) {
             LOGGER.error("Failed to get volume for category '{}'!", field.getName(), e);
             return 0.0f;
         }
     }
 
-    public static float getEffectiveVolume(SoundCategory category, GameSettings gameSettings)
-    {
+    public static float getEffectiveVolume(@NotNull SoundCategory category) {
         Field field = VOLUME_FIELDS.get(category);
         if (field == null) return 0.0f;
 
-        try
-        {
-            float value = ((OptionVolume) field.get(gameSettings)).value;
-            return value * gameSettings.masterVolume.value;
-        }
-        catch (Exception e)
-        {
+        try {
+            float value = ((OptionVolume) field.get(null)).value;
+            return value * GameSettings.MASTER_VOLUME.value;
+        } catch (Exception e) {
             LOGGER.error("Failed to get effective volume for category '{}'!", field.getName(), e);
             return 0.0f;
         }
     }
 
-    public static void setVolume(SoundCategory category, GameSettings gameSettings, float value)
-    {
+    public static void setVolume(SoundCategory category, float value) {
         Field field = VOLUME_FIELDS.get(category);
         if (field == null) return;
 
-        try
-        {
-            OptionVolume option = (OptionVolume) field.get(gameSettings);
+        try {
+            OptionVolume option = (OptionVolume) field.get(null);
             option.value = value;
-        }
-        catch (Exception e)
-        {
+        } catch (Exception e) {
             LOGGER.error("Failed to set volume for category '{}'!", field.getName(), e);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 1fae690ad..3170cea2a 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -24,14 +24,13 @@ public class SoundEngine
 {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	private static @Nullable SoundSystem soundSystem;
-	private static Lock lock = new ReentrantLock();
+	private static final Lock lock = new ReentrantLock();
 	private static boolean loaded = false;
 
 	public static final String BG_MUSIC = "BgMusic";
 	public static final String STREAMING = "Streaming";
 
 	private int idCounter;
-	private @Nullable GameSettings options;
 	private final Random random;
 	private Minecraft mc;
 	public int ticksBeforeMusic;
@@ -43,7 +42,7 @@ public class SoundEngine
     }
 
 	public void resetMusicTicks() {
-		this.ticksBeforeMusic = this.options.musicFrequency.value.interval == 0 ? 0 : this.random.nextInt(this.options.musicFrequency.value.interval);
+		this.ticksBeforeMusic = GameSettings.MUSIC_FREQUENCY.value.interval == 0 ? 0 : this.random.nextInt(GameSettings.MUSIC_FREQUENCY.value.interval);
 	}
 
 	public void destroy() {
@@ -68,7 +67,7 @@ public class SoundEngine
 			if (this.muted) {
 				soundSystem.setVolume(BG_MUSIC, 0.0f);
 			} else {
-				soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options));
+				soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC));
 			}
 		} finally {
 			lock.unlock();
@@ -101,12 +100,11 @@ public class SoundEngine
 		}
     }
 
-    public void init(final GameSettings gamesettings) {
+    public void init() {
 		try {
 			lock.lock();
-			this.options = gamesettings;
 			this.resetMusicTicks();
-			if (!isLoaded() && SoundCategoryHelper.isAnyEnabled(gamesettings)) {
+			if (!isLoaded() && SoundCategoryHelper.isAnyEnabled()) {
 				loadLibrary();
 			}
 			this.mc = Minecraft.getMinecraft();
@@ -122,10 +120,10 @@ public class SoundEngine
 				loadLibrary();
 			}
 			if (soundSystem != null && loaded) {
-				if (SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) == 0.0F) {
+				if (SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) == 0.0F) {
 					soundSystem.stop(BG_MUSIC);
 				} else {
-					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options));
+					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC));
 				}
 			}
 		} finally {
@@ -136,7 +134,7 @@ public class SoundEngine
 	public void playTitleScreenMusic() {
 		try {
 			lock.lock();
-			if (!isLoaded() || SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) == 0.0F) {
+			if (!isLoaded() || SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) == 0.0F) {
 				return;
 			}
 
@@ -150,7 +148,7 @@ public class SoundEngine
 				if (entry != null) {
 					soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
 					soundSystem.setPitch(BG_MUSIC, entry.pitch);
-					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) * entry.volume);
+					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) * entry.volume);
 					soundSystem.play(BG_MUSIC);
 				}
 			}
@@ -164,7 +162,7 @@ public class SoundEngine
     public void tick() {
 		try {
 			lock.lock();
-			if (!isLoaded() || SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) == 0.0F) {
+			if (!isLoaded() || SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) == 0.0F) {
 				return;
 			}
 
@@ -185,13 +183,13 @@ public class SoundEngine
 				final SoundEntry entry = event.getRandomEntry();
 				if (entry != null) {
 					this.resetMusicTicks();
-					this.ticksBeforeMusic += this.options.musicFrequency.value.interval;
+					this.ticksBeforeMusic += GameSettings.MUSIC_FREQUENCY.value.interval;
 					soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
 					soundSystem.setPitch(BG_MUSIC, entry.pitch);
-					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, this.options) * entry.volume);
+					soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC) * entry.volume);
 					soundSystem.play(BG_MUSIC);
 
-					if (this.options.musicToasts.value && entry.title != null) {
+					if (GameSettings.MUSIC_TOASTS.value && entry.title != null) {
 						mc.guiToasts.addToast(new MusicToast(entry.title, entry.author));
 					}
 				}
@@ -264,7 +262,7 @@ public class SoundEngine
 							}
 							volume *= 0.25F;
 							soundSystem.setPitch(soundID, pitch * entry.pitch);
-							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
+							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category) * entry.volume);
 							soundSystem.play(soundID);
 						}
 					} else if (entry.type == SoundEntry.Type.EVENT) {
@@ -318,7 +316,7 @@ public class SoundEngine
 							}
 
 							soundSystem.setPitch(soundID, pitch * entry.pitch);
-							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, this.options) * entry.volume);
+							soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category) * entry.volume);
 							soundSystem.play(soundID);
 						}
 					} else if (entry.type == SoundEntry.Type.EVENT) {
@@ -364,7 +362,7 @@ public class SoundEngine
 					if (url != null) {
 						soundSystem.newStreamingSource(true, STREAMING, url, entry.name, false, x, y, z, 2, entry.attenuationDistance);
 						soundSystem.setPitch(STREAMING, pitch * entry.pitch);
-						soundSystem.setVolume(STREAMING, volume * entry.volume * this.options.masterVolume.value);
+						soundSystem.setVolume(STREAMING, volume * entry.volume * GameSettings.MASTER_VOLUME.value);
 						soundSystem.play(STREAMING);
 					}
 				} else if (entry.type == SoundEntry.Type.EVENT) {
@@ -396,9 +394,9 @@ public class SoundEngine
 				final float[] volumeStore = new float[SoundCategory.values().length];
 				for (int i = 0; i < SoundCategory.values().length; i++)
 				{
-					volumeStore[i] = SoundCategoryHelper.getVolume(SoundCategory.values()[i], this.options);
+					volumeStore[i] = SoundCategoryHelper.getVolume(SoundCategory.values()[i]);
 				}
-				this.options.saveOptions();
+				GameSettings.saveOptions();
 				SoundSystemConfig.addLibrary(LibraryLWJGL3OpenAL.class);
 				SoundSystemConfig.setCodec("ogg", CodecJOrbis.class);
 				SoundSystemConfig.setCodec("mus", CodecMus.class);
@@ -406,9 +404,9 @@ public class SoundEngine
 				soundSystem = new SoundSystem();
 				for (int i = 0; i < SoundCategory.values().length; i++)
 				{
-					SoundCategoryHelper.setVolume(SoundCategory.values()[i], this.options, volumeStore[i]);
+					SoundCategoryHelper.setVolume(SoundCategory.values()[i], volumeStore[i]);
 				}
-				this.options.saveOptions();
+				GameSettings.saveOptions();
 			} catch (final Throwable throwable) {
 				LOGGER.error("Error linking with the LibraryJavaSound plug-in", throwable);
 			}
@@ -423,7 +421,7 @@ public class SoundEngine
 	}
 
 	private boolean canPlaySounds() {
-		return isLoaded() && !this.muted && SoundCategoryHelper.isAnyEnabled(this.options);
+		return isLoaded() && !this.muted && SoundCategoryHelper.isAnyEnabled();
 	}
 
 	public static @Nullable SoundSystem getSoundSystem(){
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 61584af1b..eeaa04eca 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.util.debug;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -178,14 +179,13 @@ public class DebugRender {
         tessellator.setColorOpaque1i(0xFF0000);
         drawRectangle(tessellator, x, y - tickLagHeight, frametimes.length, 1);
 
-        Minecraft mc = Minecraft.getMinecraft();
-        if (mc.gameSettings.customFpsLimit.value > 0 || mc.gameSettings.enableVsync.value) {
+        if (GameSettings.CUSTOM_FPS_LIMIT.value > 0 || GameSettings.ENABLE_VSYNC.value) {
             tessellator.setColorOpaque1i(0x00FF00);
             int fps;
-            if (mc.gameSettings.enableVsync.value) {
-                fps = mc.gameWindow.getFrequency(); // Cap fps when minimized
+            if (GameSettings.ENABLE_VSYNC.value) {
+                fps = Minecraft.getMinecraft().gameWindow.getFrequency(); // Cap fps when minimized
             } else {
-                fps = mc.gameSettings.customFpsLimit.value;
+                fps = GameSettings.CUSTOM_FPS_LIMIT.value;
             }
 
             int frameLagHeight = (int) ((1000d / fps * 1000 * 1000) / scale);
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
index 86d2ff837..de886090b 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
@@ -12,6 +12,7 @@ import java.io.File;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.FrameBuffer;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.texture.Texture;
@@ -50,7 +51,7 @@ public class ScreenshotHelper {
 	}
 	
 	private void takeScreenshot() throws Exception {
-        this.minecraft.gameSettings.FoV.value = 0.6056338f; //90 Degrees
+        GameSettings.FOV.value = 0.6056338f; //90 Degrees
         this.minecraft.thePlayer.yRot = 0.0f;
         this.minecraft.thePlayer.xRot = 0.0f;
         this.minecraft.thePlayer.yRotO = this.minecraft.thePlayer.yRot;
@@ -114,14 +115,14 @@ public class ScreenshotHelper {
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
 		glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, this.depthtex.id(), 0);
 
-        this.fov = this.minecraft.gameSettings.FoV.get();
+        this.fov = GameSettings.FOV.get();
         this.yaw = this.minecraft.thePlayer.yRot;
         this.pitch = this.minecraft.thePlayer.xRot;
         this.renderer = this.minecraft.renderer;
         this.oldWidth = this.minecraft.gameWindow.getWidthPixels();
         this.oldHeight = this.minecraft.gameWindow.getHeightPixels();
-        this.immersiveMode = this.minecraft.gameSettings.immersiveMode.value;
-        this.minecraft.gameSettings.immersiveMode.value = 2;
+        this.immersiveMode = GameSettings.IMMERSIVE_MODE.value;
+        GameSettings.IMMERSIVE_MODE.value = 2;
 
 //		minecraft.renderer = new FallbackRenderer(minecraft);
 	}
@@ -133,11 +134,11 @@ public class ScreenshotHelper {
         this.colortex.delete();
         this.depthtex.delete();
 
-        this.minecraft.gameSettings.FoV.value = this.fov;
+        GameSettings.FOV.value = this.fov;
         this.minecraft.thePlayer.yRot = this.yaw;
         this.minecraft.thePlayer.xRot = this.pitch;
         this.minecraft.renderer = this.renderer;
-        this.minecraft.gameSettings.immersiveMode.value = this.immersiveMode;
+        GameSettings.IMMERSIVE_MODE.value = this.immersiveMode;
 	}
 	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index d87ce142e..bdf321612 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.world;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -11,6 +11,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.AuroraProvider;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
@@ -22,14 +23,15 @@ import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.WeatherManager;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3f;
 import org.joml.Vector3fc;
 
 public class WorldClient extends World {
     public static final WorldClient EMPTY_WORLD = new WorldClient();
 
-    public WorldClient(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType) {
-        super(saveHandler, name, seed, dimension, worldType);
+    public WorldClient(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType, @Nullable Biome startingBiome) {
+        super(saveHandler, name, seed, dimension, worldType, startingBiome);
     }
 
     public WorldClient(World world, Dimension dimension) {
@@ -161,6 +163,6 @@ public class WorldClient extends World {
 
     @Override
     public int renderDistance() {
-        return Minecraft.getMinecraft().gameSettings.renderDistance.value;
+        return GameSettings.RENDER_DISTANCE.value;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index a8ec4bc9d..7388c1042 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -10,12 +10,15 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.client.world.save.SaveHandlerClientMP;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.HashSet;
 import java.util.LinkedList;
@@ -56,8 +59,8 @@ public class WorldClientMP extends WorldClient {
         for (int l = 0; l < this.positionTypesList.size(); l++) {
             WorldBlockPositionType worldblockpositiontype = this.positionTypesList.get(l);
             if (--worldblockpositiontype.delayTicks == 0) {
-                super.setBlockAndMetadata(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z, worldblockpositiontype.blockId, worldblockpositiontype.metadata);
-                super.markBlockNeedsUpdate(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z);
+                super.setBlockTypeData(worldblockpositiontype.blockPos, worldblockpositiontype.block, worldblockpositiontype.metadata);
+                super.markBlockNeedsUpdate(worldblockpositiontype.blockPos);
                 this.positionTypesList.remove(l--);
             }
         }
@@ -71,10 +74,15 @@ public class WorldClientMP extends WorldClient {
         this.sendQueue.tick();
     }
 
-    public void removePositionTypesInBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ) {
+    public void removePositionTypesInBounds(@NotNull TilePosc min, @NotNull TilePosc max) {
         for (int i = 0; i < this.positionTypesList.size(); i++) {
             WorldBlockPositionType worldblockpositiontype = this.positionTypesList.get(i);
-            if (worldblockpositiontype.x >= minX && worldblockpositiontype.y >= minY && worldblockpositiontype.z >= minZ && worldblockpositiontype.x <= maxX && worldblockpositiontype.y <= maxY && worldblockpositiontype.z <= maxZ) {
+            if (worldblockpositiontype.blockPos.x() >= min.x() &&
+                worldblockpositiontype.blockPos.y() >= min.y() &&
+                worldblockpositiontype.blockPos.z() >= min.z() &&
+                worldblockpositiontype.blockPos.x() <= max.x() &&
+                worldblockpositiontype.blockPos.y() <= max.y() &&
+                worldblockpositiontype.blockPos.z() <= max.z()) {
                 this.positionTypesList.remove(i--);
             }
         }
@@ -106,14 +114,14 @@ public class WorldClientMP extends WorldClient {
         return false;
     }
 
-    public void doPreChunk(int chunkX, int chunkZ, boolean playerAdded) {
+    public void doPreChunk(@NotNull ChunkPos chunkPos, boolean playerAdded) {
         if (playerAdded) {
-            this.chunkCache.prepareChunk(chunkX, chunkZ);
+            this.chunkCache.prepareChunk(chunkPos, true);
         } else {
-            this.chunkCache.dropChunk(new ChunkPos(chunkX, chunkZ));
+            this.chunkCache.dropChunk(chunkPos);
         }
         if (!playerAdded) {
-            markBlocksDirty(chunkX * 16, 0, chunkZ * 16, chunkX * 16 + 15, getHeightBlocks(), chunkZ * 16 + 15);
+            markBlocksDirty(new TilePos(chunkPos.x() * Chunk.CHUNK_SIZE_X, 0, chunkPos.z() * Chunk.CHUNK_SIZE_Z), new TilePos(chunkPos.x() * Chunk.CHUNK_SIZE_X + 15, getHeightBlocks(), chunkPos.z() * Chunk.CHUNK_SIZE_Z + 15));
         }
     }
 
@@ -165,7 +173,7 @@ public class WorldClientMP extends WorldClient {
         return this.entitiesById.get(i);
     }
 
-    public Entity removeEntityFromWorld(int i) {
+    public @Nullable Entity removeEntityFromWorld(int i) {
         Entity entity = this.entitiesById.remove(i);
         if (entity != null) {
             this.forced.remove(entity);
@@ -179,7 +187,7 @@ public class WorldClientMP extends WorldClient {
         final @NotNull Block<?> block = this.getBlockType(tilePos);
         final int currentData = this.getBlockData(tilePos);
         if (super.setBlockData(tilePos, data)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), block.id(), currentData));
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos, block, currentData));
             return true;
         } else {
             return false;
@@ -191,7 +199,7 @@ public class WorldClientMP extends WorldClient {
         final @NotNull Block<?> currentBlock = this.getBlockType(tilePos);
         final int currentData = this.getBlockData(tilePos);
         if (super.setBlockTypeData(tilePos, block, data)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentBlock.id(), currentData));
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos, currentBlock, currentData));
             return true;
         } else {
             return false;
@@ -203,17 +211,17 @@ public class WorldClientMP extends WorldClient {
         final @NotNull Block<?> currentBlock = this.getBlockType(tilePos);
         final int currentData = this.getBlockData(tilePos);
         if (super.setBlockType(tilePos, block)) {
-            this.positionTypesList.add(new WorldBlockPositionType(tilePos.x(), tilePos.y(), tilePos.z(), currentBlock.id(), currentData));
+            this.positionTypesList.add(new WorldBlockPositionType(tilePos, currentBlock, currentData));
             return true;
         } else {
             return false;
         }
     }
 
-    public boolean blockChange(int x, int y, int z, int id, int meta) {
-        removePositionTypesInBounds(x, y, z, x, y, z);
-        if (super.setBlockAndMetadata(x, y, z, id, meta)) {
-            notifyBlockChange(x, y, z, id);
+    public boolean blockChange(@NotNull TilePosc blockPos, @NotNull Block<?> block, int meta) {
+        removePositionTypesInBounds(blockPos, blockPos);
+        if (super.setBlockTypeData(blockPos, block, meta)) {
+            notifyBlockChange(blockPos, block);
             return true;
         } else {
             return false;
@@ -231,19 +239,15 @@ public class WorldClientMP extends WorldClient {
     }
 
     static class WorldBlockPositionType {
-        int x;
-        int y;
-        int z;
+        final @NotNull TilePosc blockPos;
         int delayTicks;
-        int blockId;
-        int metadata;
+        final @NotNull Block<?> block;
+        final int metadata;
 
-        public WorldBlockPositionType(int x, int y, int z, int blockId, int metadata) {
-            this.x = x;
-            this.y = y;
-            this.z = z;
+        public WorldBlockPositionType(@NotNull TilePosc blockPos, @NotNull Block<?> block, int metadata) {
+            this.blockPos = new TilePos(blockPos);
             this.delayTicks = 80;
-            this.blockId = blockId;
+            this.block = block;
             this.metadata = metadata;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index e8671ca22..cb86c1179 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.world.chunk.provider;
 
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -11,24 +12,32 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
-public class ChunkProviderClient
-    implements IChunkProvider {
+public class ChunkProviderClient implements IChunkProvider {
+    protected static final @NotNull ChunkPos MIN_POS = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
+
     private final @NotNull Chunk blankChunk;
-    private final @NotNull Map<ChunkPos, Chunk> chunkMapping;
-    private final @NotNull List<Chunk> chunks;
-    private final @NotNull World worldObj;
+    private final @NotNull Map<ChunkPos, Chunk> chunkMapping = new Object2ObjectOpenHashMap<>();
+    private final @NotNull World world;
+
 
+    protected @NotNull Chunk lastQueriedChunk;
+    protected @NotNull ChunkPos lastQueriedChunkPos = MIN_POS;
 
     public ChunkProviderClient(@NotNull World world) {
-        this.chunkMapping = new HashMap<>();
-        this.chunks = new ArrayList<>();
-        this.blankChunk = new EmptyChunk(world, 0, 0);
-        this.worldObj = world;
+        this.blankChunk = new EmptyChunk(world, new ChunkPos(0, 0));
+        this.lastQueriedChunk = this.blankChunk;
+        this.world = world;
     }
 
     @Override
     public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
-        return this.chunkMapping.containsKey(chunkPos);
+        if (chunkPos.equals(this.lastQueriedChunkPos)) return true;
+        if (this.chunkMapping.containsKey(chunkPos)) {
+            this.lastQueriedChunkPos = new ChunkPos(chunkPos);
+            this.lastQueriedChunk = this.chunkMapping.get(chunkPos);
+            return true;
+        }
+        return false;
     }
 
     @Override
@@ -41,13 +50,12 @@ public class ChunkProviderClient
             chunk.onUnload();
         }
         this.chunkMapping.remove(chunkPos);
-        this.chunks.remove(chunk);
     }
 
     @Override
     public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
         if (this.chunkMapping.containsKey(chunkPos)) return this.chunkMapping.get(chunkPos);
-        Chunk chunk = new Chunk(this.worldObj, new ChunkPos(chunkPos));
+        Chunk chunk = new Chunk(this.world, new ChunkPos(chunkPos));
         this.chunkMapping.put(chunk.pos, chunk);
         chunk.isLoaded = true;
         return chunk;
@@ -55,17 +63,18 @@ public class ChunkProviderClient
 
     @Override
     public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.equals(this.lastQueriedChunkPos)) return this.lastQueriedChunk;
         Chunk chunk = this.chunkMapping.get(chunkPos);
-        if (chunk == null) {
-            return this.blankChunk;
-        } else {
+        if (chunk != null) {
+            this.lastQueriedChunkPos = chunkPos;
+            this.lastQueriedChunk = chunk;
             return chunk;
         }
+        return this.blankChunk;
     }
 
     @Override
     public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
-
         return true;
     }
 
diff --git a/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
index 6f4c58628..e13df5d80 100644
--- a/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
+++ b/game/client/src/main/java/org/useless/dragonfly/DisplayPos.java
@@ -7,7 +7,7 @@ import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
-import net.minecraft.client.render.block.model.BlockModel;
+import org.jetbrains.annotations.NotNull;
 import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 import org.useless.util.GsonHelper;
 
